Name: MAKEDEV
Version: 3.1.0
Release: 14
Group: System Environment/Base
License: GPL
Source: MAKEDEV-%{version}-%{release}.tar.gz
Summary: A program used for creating the device files in /dev.
BuildRoot: %{_tmppath}/%{name}-root

%define makedev $RPM_BUILD_ROOT/dev/MAKEDEV -c $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d -d $RPM_BUILD_ROOT/dev

%description
This package contains the MAKEDEV script, which makes it easier to create
and maintain the files in the /dev directory.  /dev directory files
correspond to a particular device supported by Linux (serial or printer
ports, scanners, sound cards, tape drives, CD-ROM drives, hard drives,
etc.) and interface with the drivers in the kernel.

You should install the MAKEDEV package because the MAKEDEV utility makes
it easy to manage the /dev directory device files.

%package -n dev
Group: System Environment/Base
Summary: The most commonly-used entries in the /dev directory.
Prereq: /usr/sbin/groupadd, /bin/mkdir

%description -n dev
The Red Hat Linux operating system uses file system entries to represent
devices (CD-ROMs, floppy drives, etc.) attached to the machine. All of
these entries are in the /dev tree (although they don't have to be).
This package contains the most commonly used /dev entries.

The dev package is a basic part of your Red Hat Linux system and it needs
to be installed.

%prep
%setup -q

%build
make OPTFLAGS="$RPM_OPT_FLAGS"

%install
rm -fr $RPM_BUILD_ROOT
%{makeinstall} devdir=$RPM_BUILD_ROOT/dev
%makedev -m 1 log

%ifarch s390 s390x
%makedev initrd
%makedev ipfilter
%makedev -m 32 loop
%makedev md
%makedev nb
%makedev ptmx
%makedev pty
%makedev -m 20 ram
%makedev random
%makedev raw
%makedev systty
%makedev std
%makedev -m 32 tty
%makedev urandom
%makedev dasd
%makedev xpram
%makedev mnd
# we have a special console
mknod -m 0600 $RPM_BUILD_ROOT/dev/console c 4 64
rm -f $RPM_BUILD_ROOT/dev/vcs*
rm -f $RPM_BUILD_ROOT/dev/fd[0-7]*
%else
%makedev agpgart
%makedev capi20
%makedev cciss/c
%makedev cdrom
%makedev -m 32 console
%makedev -m 4 cua
%makedev -m 64 cui
%ifarch ia64
%makedev efirtc
%endif
%makedev enskip
%makedev fb
%makedev fd
%makedev ftape
%makedev -m 2 ht
%makedev -m 2 i2c
%makedev i2o
%makedev ida/c
%makedev ibcs
%makedev -m 17 ide
%makedev initrd
%makedev input
%makedev ip
%makedev ir
%makedev -m 2 iscc
%makedev isdn
%makedev ixj
%makedev -m 4 js
%makedev -m 16 loop
%makedev -m 3 lp
%makedev md
%makedev mouse
%makedev nb
%makedev netlink
%makedev -m 2 nht
%makedev nst
%makedev -m 3 par
%makedev -m 4 pcd
%makedev pd
%makedev -m 4 pf
%makedev -m 4 pg
%makedev -m 4 ppp
%makedev pt
%makedev ptmx
%makedev pty
%makedev qng
%makedev -m 20 ram
%makedev rd/c
%makedev random
%makedev raw
%makedev rmt
%makedev rtc
%makedev -m 8 scd
%makedev sd
%makedev -m 16 sg
%makedev smpt
%makedev sound
%makedev st
%makedev systty
%makedev -m 4 staliomem
%makedev std
%makedev tlk
%makedev -m 32 tty
%makedev urandom
%makedev usb
%makedev -m 4 v4l
%makedev vcs
%makedev vmmon
%makedev -m 4 vnet
%makedev -m 4 winradio
%makedev xda
%makedev xdb
%endif

%ifarch sparc sparc64
%makedev kbd
%makedev openprom
ln -s sunmouse $RPM_BUILD_ROOT/dev/mouse
%makedev audioctl
for dev in aztcd cdu31a cdu535 cm205cd cm206cd gscd hitcd mcd mcdx \
	sbpcd1 sbpcd2 scd3 sjcd sbpcd3 sonycd sbpcd sbpcd0 \
	atibm inportbm logibm ; do
	rm -f $RPM_BUILD_ROOT/dev/$dev
done
%endif

# Make subdirectories we otherwise would have nothing to do with.
install -d -m 755 $RPM_BUILD_ROOT/dev/pts

# Generate a list of the device nodes.
find $RPM_BUILD_ROOT/dev -maxdepth 1 -mindepth 1 -not -name MAKEDEV -not -name log | sed -e "s|$RPM_BUILD_ROOT||g" | tee manifest

%clean
rm -fr $RPM_BUILD_ROOT

%pre
if [ -r /proc/mounts ] ; then
	(while read source mountpoint rest ; do
		if [ "$mountpoint" = /dev ] ; then
			exit 1
		fi
	 done
	 exit 0 ) < /proc/mounts
	MOUNTED=$?
	if [ "$MOUNTED" -ne 0 ] ; then
		echo $"Cannot install the %{name} package: mounted devfs detected."
		exit $MOUNTED
	fi
fi

%pre -n dev
if [ -r /proc/mounts ] ; then
	(while read source mountpoint rest ; do
		if [ "$mountpoint" = /dev ] ; then
			exit 1
		fi
	 done
	 exit 0 ) < /proc/mounts
	MOUNTED=$?
	if [ "$MOUNTED" -ne 0 ] ; then
		echo $"Cannot install the dev package: mounted devfs detected."
		exit $MOUNTED
	fi
fi
if [ ! -d /dev ] ; then
	/bin/mkdir /dev
fi
/usr/sbin/groupadd -g 19 -r -f floppy > /dev/null 2>/dev/null ||:
exit 0

%post -n dev
if [ -f /etc/fstab ] ; then
  # add /dev/pts to fstab if fstab exists (install2 does it during install)
  if grep 'devpts' /etc/fstab >/dev/null 2>&1 ; then 
      # correct permissions from broken dev packages
      TMP=$(mktemp /tmp/fstab.XXXXXX)
      sed 's/devpts.*mode=0622/devpts  gid=5,mode=620/g' < /etc/fstab > $TMP && cat $TMP > /etc/fstab || { echo "failed to correct devpts permissions in /etc/fstab" 1>&2 ; exit 1 ; }
      rm -f $TMP
  else
    # note that we do not disallow comments; we wish to allow people
    # to comment it out if they so desire.
    if [ $(grep '/proc' /dev/fstab 2>/dev/null | wc -l) -gt 1 ] ; then
      # ugly but robust
      echo '
none                    /dev/pts                devpts  gid=5,mode=620        0 0' \
        >> /etc/fstab || { echo "failed to add devpts filesystem to /etc/fstab" 1>&2 ; exit 1 ; }
    else
      # beautiful in the common case
      TMP=$(mktemp /tmp/fstab.XXXXXX)
      sed '/\/proc/a\
none                    /dev/pts                devpts  gid=5,mode=620        0 0
          ' < /etc/fstab > $TMP && cat $TMP > /etc/fstab || { echo "failed to add devpts filesystem to /etc/fstab" 1>&2 ; exit 1 ; }
      rm -f $TMP
    fi
  fi
fi
if [ -x /sbin/pam_console_apply ] ; then
  /sbin/pam_console_apply
fi

%files
%defattr(-,root,root)
%doc COPYING devices.txt
/dev/MAKEDEV
%{_mandir}/man8/*
%config %{_sysconfdir}/makedev.d/*

%files -n dev -f manifest
%dir %attr(0755,root,root) /dev
%ghost /dev/log

%changelog
* Fri Mar 23 2001 Nalin Dahyabhai <nalin@redhat.com> 
- make all devices for all RAID controllers again

* Mon Mar 12 2001 Nalin Dahyabhai <nalin@redhat.com> 
- make aliases for ide5 through ide9
- limit the number of console and console-related devices to 32
- run pam_console_apply in the post, if it exists

* Mon Mar  5 2001 Nalin Dahyabhai <nalin@redhat.com> 
- use a file manifest

* Sat Mar  3 2001 Nalin Dahyabhai <nalin@redhat.com> 
- drop the number of hdX devices from 33 to 17, on advice from Andre Hedrick

* Thu Mar  1 2001 Nalin Dahyabhai <nalin@redhat.com> 
- make js0, js1, js2, js3 symlinks into /dev/input so that all programs use
  the new input-core joystick driver instead of the old one

* Mon Feb 26 2001 Nalin Dahyabhai <nalin@redhat.com> 
- detect devfs in the MAKEDEV %%pre, too (#26110)
- fix message in the dev %%pre (#26110)

* Fri Feb 16 2001 Nalin Dahyabhai <nalin@redhat.com> 
- build the netlink device (#15785)

* Sun Feb 11 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- merge in s390 s390x support

* Tue Feb  6 2001 Nalin Dahyabhai <nalin@redhat.com>
- fail to install if %%pre detects devfs

* Thu Jan 25 2001 Nalin Dahyabhai <nalin@redhat.com>
- create /dev in the %%pre script; installing the dev package should fixup
  the permissions, and we can't redirect to /dev/null without it (#24392)

* Thu Jan 18 2001 Nalin Dahyabhai <nalin@redhat.com>
- make /dev/aio world-writable (info from Ben LeHaise)

* Wed Jan 17 2001 Nalin Dahyabhai <nalin@redhat.com>
- add device nodes using the new devices.txt for Linux 2.4.0, and check that
  file into the source tree to make tracking further changes simpler
- change Copyright: GPL to License: GPL
- add a very simple substitution macro facility for specifying ownership and
  permissions in a single place
- add code for creating sockets natively
- remove conflicting data for where /dev/ftape should point to
- remove all raid controller device nodes for second and additional controllers
  (they can be created with MAKEDEV)

* Tue Jan  9 2001 Nalin Dahyabhai <nalin@redhat.com>
- make 32 partition devices for IDE disks instead of 16

* Tue Dec 12 2000 Nalin Dahyabhai <nalin@redhat.com>
- make some ppp devices

* Thu Oct 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- change vcs0 to vcs (ditto for vcsa0)

* Tue Sep 12 2000 Bill Nottingham <notting@redhat.com>
- fixes for some sparc devices that fell out

* Thu Aug 24 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- change some devices that could be used for dialing to root:uucp/0660 perms

* Wed Aug 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- up the number of SCSI CD-ROM devices we know about from 8 to 32, but only
  create 8 at build-time

* Wed Aug 16 2000 Nalin Dahyabhai <nalin@redhat.com>
- remove both temp files generated in the %post (#16325)

* Mon Aug 14 2000 Nalin Dahyabhai <nalin@redhat.com>
- change the sense of sga/sg0 node/symlink stuff to match kernel docs (#16056)

* Wed Aug  9 2000 Nalin Dahyabhai <nalin@redhat.com>
- add the netlink device, and mark it as undocumented (#15785)
- add /dev/log socket as a ghost using Erik's mksocket
- add in devices that start with "m"
- change /dev/i20 to /dev/i2o
- fix a parser bug

* Tue Aug  8 2000 Nalin Dahyabhai <nalin@redhat.com>
- add cciss device nodes (#14878)

* Mon Aug  7 2000 Crutcher Dunnavant <crutcher@redhat.com>
- make the usb lp? devices group-owned by 'lp'

* Fri Jul 21 2000 Nalin Dahyabhai <nalin@redhat.com>
- make floppy disk devices group-accessible by the floppy group

* Wed Jul 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- stop making bogus symlinks (#14225)
- add "console" alias for tty devices to match man page
- add "qic" alias for tape devices to match man page

* Mon Jul 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- change group of the "lp" devices to "lp"
- comment out the ACSI disks, which probably shouldn't have those names
- incorporate the release number into the tarball file name

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jul 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix symlink creation where both the link and a target are in a subdirectory
- add efirtc in its own "ia64" control file

* Wed Jul  5 2000 Nalin Dahyabhai <nalin@redhat.com>
- add a -i flag so that I can test in a CVS checkout
- use correct IBCS compatibility device entries
- fix symlink creation so that it works as intended

* Tue Jul  4 2000 Matt Wilson <msw@redhat.com>
- moved the Prereq: /usr/sbin/groupadd from the MAKEDEV package to the
  dev package
- added the %%post script to the dev package to add devpts mounting

* Sat Jul  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- make the man page 644, not 755

* Mon Jun 26 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- update from 8 to 16 loop devices

* Mon Jun 26 2000 Nalin Dahyabhai <nalin@redhat.com>
- add input/mice and md devices to the dev package
- limit loop devices to 16 in config files (this is a hard-coded kernel limit)

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- add the "floppy" group to the system in the dev package's pre-install

* Mon Jun 11 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix a typo in the devices list
- move non-standard names from linux-2.2 list to redhat list

* Sat Jun 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- FHS packaging for a shiny new version
